"""init db

迁移 ID: 4bc53bd04337
父迁移:
创建时间: 2024-01-14 17:39:41.845932

"""

from __future__ import annotations

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

revision: str = "4bc53bd04337"
down_revision: str | Sequence[str] | None = None
branch_labels: str | Sequence[str] | None = ("nonebot_plugin_skland_arksign",)
depends_on: str | Sequence[str] | None = None


def upgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "skland_subscribe",
        sa.Column("uid", sa.String(), nullable=False),
        sa.Column(
            "user",
            sa.JSON().with_variant(postgresql.JSONB(astext_type=sa.Text()), "postgresql"),
            nullable=False,
        ),
        sa.Column("cred", sa.String(), nullable=False),
        sa.Column("token", sa.String(), nullable=True),
        sa.Column("note", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("uid", name=op.f("pk_skland_subscribe")),
        sa.UniqueConstraint("note"),
        info={"bind_key": "nonebot_plugin_skland_arksign"},
    )
    # ### end Alembic commands ###


def downgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("skland_subscribe")
    # ### end Alembic commands ###
